require 'active_support'
require File.expand_path('display_types/google_map',File.dirname(__FILE__))

module ActionView
  module Helpers
    module AutoTagHelper
      module DisplayTypes

        @@display_types = {}

        # ==== For examples
        #   module MyGoogleMapByLatLon
        #     def self.display_tag latlon
        #       lat = latlon[:lat]
        #       lon = latlon[:lon]
        #       ...
        #     end
        #   end
        #
        #   ActionView::Helpers::AutoTagHelper::DisplayTypes.register(:google_map_latlon, MyGoogleMapByLatLon)
        #
        #   class User < ActiveRecord::Base
        #     set_display_type(:myhome_coodinates, :google_map_latlon)
        #     def myhome_coodinates
        #       {lat: self.lat, lon: self.lon}
        #     end
        #   end
        #
        #   user = User.find(1)
        #   display_tag(:myhome_coodinates, user, width: 600, height: 350)
        #   # => MyGoogleMapByLatLon.display_tag(user.myhome_coodinates,width: 600, height: 350)
        def self.register(type_name, obj)
          @@display_types[type_name.to_sym]=obj
        end

        # register(:google_map_latlon, GoogleMapByLatLon)
        # get(:google_map_latlon)
        #   # => GoogleMapByLatLon
        def self.get(type_name)
          type_name.present? ? @@display_types[type_name.to_sym] : nil
        end

        def self.[](type_name)
          get(type_name)
        end
      end
      DisplayTypes.register(:google_map_lat_lon, DisplayTypes::GoogleMapLatLon)
    end
  end
end

